unit JogControl;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, Buttons, StdCtrls;

type
  TFormJogControl = class(TForm)
    GroupBoxJogControl: TGroupBox;
    ButtonJogAMinus: TButton;
    ButtonJogAPlus: TButton;
    ButtonJogZMinus: TButton;
    ButtonJogZPlus: TButton;
    ButtonJogXMinus: TButton;
    ButtonJogYMinus: TButton;
    ButtonJogYPlus: TButton;
    ButtonJogXPlus: TButton;
    ButtonAMinus1: TButton;
    ButtonAPlus1: TButton;
    ButtonZMinus1: TButton;
    ButtonZPlus1: TButton;
    ButtonYMinus1: TButton;
    ButtonYPlus1: TButton;
    ButtonXMinus1: TButton;
    ButtonXPlus1: TButton;
    ButtonAMinus10: TButton;
    ButtonAPlus10: TButton;
    ButtonZMinus10: TButton;
    ButtonZPlus10: TButton;
    ButtonYMinus10: TButton;
    ButtonYPlus10: TButton;
    ButtonXMinus10: TButton;
    ButtonXPlus10: TButton;
    ButtonClose: TBitBtn;
    procedure ButtonXPlus10Click(Sender: TObject);
    procedure ButtonXPlus1Click(Sender: TObject);
    procedure ButtonJogXPlusClick(Sender: TObject);
    procedure ButtonJogXMinusClick(Sender: TObject);
    procedure ButtonXMinus1Click(Sender: TObject);
    procedure ButtonXMinus10Click(Sender: TObject);
    procedure ButtonYPlus10Click(Sender: TObject);
    procedure ButtonYPlus1Click(Sender: TObject);
    procedure ButtonJogYPlusClick(Sender: TObject);
    procedure ButtonJogYMinusClick(Sender: TObject);
    procedure ButtonYMinus1Click(Sender: TObject);
    procedure ButtonYMinus10Click(Sender: TObject);
    procedure ButtonZPlus10Click(Sender: TObject);
    procedure ButtonZPlus1Click(Sender: TObject);
    procedure ButtonJogZPlusClick(Sender: TObject);
    procedure ButtonJogZMinusClick(Sender: TObject);
    procedure ButtonZMinus1Click(Sender: TObject);
    procedure ButtonZMinus10Click(Sender: TObject);
    procedure ButtonAPlus10Click(Sender: TObject);
    procedure ButtonAPlus1Click(Sender: TObject);
    procedure ButtonJogAPlusClick(Sender: TObject);
    procedure ButtonJogAMinusClick(Sender: TObject);
    procedure ButtonAMinus1Click(Sender: TObject);
    procedure ButtonAMinus10Click(Sender: TObject);
    procedure FormShow(Sender: TObject);
  private
    { Private declarations }
  public
    { Public declarations }
  end;

var
  FormJogControl: TFormJogControl;

implementation

uses
  DeskWinApi, DeskWinCNC, Main;

{$R *.dfm}

procedure TFormJogControl.FormShow(Sender: TObject);
begin
  Self.Left := Screen.Width - Self.Width;  // position at bottom right
  Self.Top := FormMain.Height - Self.Height;
end;

procedure TFormJogControl.ButtonXPlus1Click(Sender: TObject);
begin
  JogX := 1;
  JogY := 0;
  JogZ := 0;
  JogA := 0;
  Jog;
  FormMain.UpdateStatus;
end;

procedure TFormJogControl.ButtonYMinus10Click(Sender: TObject);
begin
  JogX := 0;
  JogY := -10;
  JogZ := 0;
  JogA := 0;
  Jog;
  FormMain.UpdateStatus;
end;

procedure TFormJogControl.ButtonYMinus1Click(Sender: TObject);
begin
  JogX := 0;
  JogY := -1;
  JogZ := 0;
  JogA := 0;
  Jog;
  FormMain.UpdateStatus;
end;

procedure TFormJogControl.ButtonYPlus10Click(Sender: TObject);
begin
  JogX := 0;
  JogY := 10;
  JogZ := 0;
  JogA := 0;
  Jog;
  FormMain.UpdateStatus;
end;

procedure TFormJogControl.ButtonYPlus1Click(Sender: TObject);
begin
  JogX := 0;
  JogY := 1;
  JogZ := 0;
  JogA := 0;
  Jog;
  FormMain.UpdateStatus;
end;

procedure TFormJogControl.ButtonZMinus10Click(Sender: TObject);
begin
  JogX := 0;
  JogY := 0;
  JogZ := -10;
  JogA := 0;
  Jog;
  FormMain.UpdateStatus;
end;

procedure TFormJogControl.ButtonZMinus1Click(Sender: TObject);
begin
  JogX := 0;
  JogY := 0;
  JogZ := -1;
  JogA := 0;
  Jog;
  FormMain.UpdateStatus;
end;

procedure TFormJogControl.ButtonZPlus10Click(Sender: TObject);
begin
  JogX := 0;
  JogY := 0;
  JogZ := 10;
  JogA := 0;
  Jog;
  FormMain.UpdateStatus;
end;

procedure TFormJogControl.ButtonZPlus1Click(Sender: TObject);
begin
  JogX := 0;
  JogY := 0;
  JogZ := 1;
  JogA := 0;
  Jog;
  FormMain.UpdateStatus;
end;

procedure TFormJogControl.ButtonAMinus10Click(Sender: TObject);
begin
  JogX := 0;
  JogY := 0;
  JogZ := 0;
  JogA := -10;
  Jog;
  FormMain.UpdateStatus;
end;

procedure TFormJogControl.ButtonAMinus1Click(Sender: TObject);
begin
  JogX := 0;
  JogY := 0;
  JogZ := 0;
  JogA := -1;
  Jog;
  FormMain.UpdateStatus;
end;

procedure TFormJogControl.ButtonAPlus10Click(Sender: TObject);
begin
  JogX := 0;
  JogY := 0;
  JogZ := 0;
  JogA := 10;
  Jog;
  FormMain.UpdateStatus;
end;

procedure TFormJogControl.ButtonAPlus1Click(Sender: TObject);
begin
  JogX := 0;
  JogY := 0;
  JogZ := 0;
  JogA := 1;
  Jog;
  FormMain.UpdateStatus;
end;

procedure TFormJogControl.ButtonJogAMinusClick(Sender: TObject);
begin
  JogX := 0;
  JogY := 0;
  JogZ := 0;
  JogA := -1 / CNCAStepsPerRev * 360;
  Jog;
  FormMain.UpdateStatus;
end;

procedure TFormJogControl.ButtonJogAPlusClick(Sender: TObject);
begin
  JogX := 0;
  JogY := 0;
  JogZ := 0;
  JogA := 1 / CNCAStepsPerRev * 360;
  Jog;
  FormMain.UpdateStatus;
end;

procedure TFormJogControl.ButtonJogXMinusClick(Sender: TObject);
begin
  JogX := -1 / CNCXStepsPerMM;
  JogY := 0;
  JogZ := 0;
  JogA := 0;
  Jog;
  FormMain.UpdateStatus;
end;

procedure TFormJogControl.ButtonJogXPlusClick(Sender: TObject);
begin
  JogX := 1 / CNCXStepsPerMM;
  JogY := 0;
  JogZ := 0;
  JogA := 0;
  Jog;
  FormMain.UpdateStatus;
end;

procedure TFormJogControl.ButtonJogYMinusClick(Sender: TObject);
begin
  JogX := 0;
  JogY := -1 / CNCYStepsPerMM;
  JogZ := 0;
  JogA := 0;
  Jog;
  FormMain.UpdateStatus;
end;

procedure TFormJogControl.ButtonJogYPlusClick(Sender: TObject);
begin
  JogX := 0;
  JogY := 1 / CNCYStepsPerMM;
  JogZ := 0;
  JogA := 0;
  Jog;
  FormMain.UpdateStatus;
end;

procedure TFormJogControl.ButtonJogZMinusClick(Sender: TObject);
begin
  JogX := 0;
  JogY := 0;
  JogZ := -1 / CNCZStepsPerMM;
  JogA := 0;
  Jog;
  FormMain.UpdateStatus;
end;

procedure TFormJogControl.ButtonJogZPlusClick(Sender: TObject);
begin
  JogX := 0;
  JogY := 0;
  JogZ := 1 / CNCZStepsPerMM;
  JogA := 0;
  Jog;
  FormMain.UpdateStatus;
end;

procedure TFormJogControl.ButtonXMinus10Click(Sender: TObject);
begin
  JogX := -10;
  JogY := 0;
  JogZ := 0;
  JogA := 0;
  Jog;
  FormMain.UpdateStatus;
end;

procedure TFormJogControl.ButtonXMinus1Click(Sender: TObject);
begin
  JogX := -1;
  JogY := 0;
  JogZ := 0;
  JogA := 0;
  Jog;
  FormMain.UpdateStatus;
end;

procedure TFormJogControl.ButtonXPlus10Click(Sender: TObject);
begin
  JogX := 10;
  JogY := 0;
  JogZ := 0;
  JogA := 0;
  Jog;
  FormMain.UpdateStatus;
end;

end.
